# $Id: cone.spec.in,v 1.6 2003/11/15 19:26:45 mrsam Exp $

# Custom build against libcurses-5.3

%define custom_curses %(test -d /usr/include/ncursesw >/dev/null 2>&1 && echo 0 && exit 0; echo 1)

%if %custom_curses
%define curses_include_dir  /usr/include/ncurses53w
%define curses_lib_dir /usr/lib/ncurses53

BuildPreReq: %{curses_include_dir}
BuildPreReq: %{curses_lib_dir}

%else
BuildPreReq: ncurses-devel

%define curses_include_dir  /usr/include/ncursesw

%endif

%define is_not_mandrake %(test ! -e /etc/mandrake-release && echo 1 || echo 0)

%define import_rootcerts %(rpm -q courier >/dev/null 2>&1 && echo 1 || echo 0)

%if %is_not_mandrake
%define cone_release %(release="`rpm -q --queryformat='.%{VERSION}' redhat-release 2>/dev/null`" ; if test $? != 0 ; then release="`rpm -q --queryformat='.%{VERSION}' fedora-release 2>/dev/null`" ; if test $? != 0 ; then release="" ; fi ; fi ; echo "$release")
%else
%define cone_release mdk
%endif

Summary: CONE mail reader
Name: cone
Version: 0.57
Release: 1%{cone_release}
URL: http://www.courier-mta.org/cone
Source0: %{name}-%{version}.tar.bz2
License: GPL
Group: Applications/Internet
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot


BuildPreReq: aspell-devel libxml2-devel
BuildPreReq: zlib-devel openssl-devel fam-devel perl
BuildPreReq: libstdc++-devel gcc-c++

%if %is_not_mandrake
BuildPreReq: openssl-perl
%endif

%if %import_rootcerts
Requires: %(eval `courier-config` ; echo $datadir/rootcerts )
%endif

Requires(post): %{__perl}

%description
CONE is a simple, text-based E-mail reader and writer.

%package devel
Group: Development/Libraries
Summary: LibMAIL mail client development library.
Requires: %{name}

%description devel
The %{name}-devel package the header files and library files for developing
application using LibMAIL - a high level, C++ OO library for mail clients.

%prep
%setup -q

CPPFLAGS="$CPPFLAGS -I %{curses_include_dir}"
export CPPFLAGS
%if %custom_curses
LDFLAGS="$LDFLAGS -L %{curses_lib_dir}"
export LDFLAGS
%endif

%configure --with-devel
%build
%{__make}
%install
rm -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
%{__install} sysconftool $RPM_BUILD_ROOT%{_datadir}/cone/cone.sysconftool

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{__perl} %{_datadir}/cone/cone.sysconftool %{_sysconfdir}/cone.dist >/dev/null

%files
%defattr(-,root,root)
%{_sysconfdir}/cone.dist
%{_bindir}/*
%{_libexecdir}/cone
%{_datadir}/cone
%{_mandir}/man1/*
%doc ABOUT-NLS ChangeLog README NEWS AUTHORS COPYING COPYING.GPL
%doc cone/html

%files devel
%defattr(-,root,root)
%{_libdir}/*.a
%{_mandir}/man[35]/*
%{_includedir}/libmail

%changelog
* Mon Sep  1 2003 Mr. Sam <sam@email-scan.com>
- Fix for Red Hat 9+

* Sat Jul 26 2003 Mr. Sam 0.52
- Use wide-char compatible ncurses in current RH Beta.

* Wed Mar  5 2003 Mr. Sam <mrsam@courier-mta.com>
- Initial build.

