/* $Id: cursesattachmentdisplay.H,v 1.2 2003/06/13 06:50:08 mrsam Exp $
**
** Copyright 2003, Double Precision Inc.
**
** See COPYING for distribution information.
*/

#ifndef cursesattachmentdisplay_H
#define cursesattachmentdisplay_H

#include "config.h"
#include "curses/mycurses.H"
#include "curses/cursescontainer.H"
#include "curses/cursesbutton.H"
#include "curses/curseskeyhandler.H"
#include "mymessage.H"
#include "libmail/objectmonitor.H"

#include <list>
#include <string>
#include <vector>

class CursesMessage;

class mail::mimestruct;

////////////////////////////////////////////////////////////////
//
// A list of message's attachments.  We take a mimestruct, and
// unwrap it.

class CursesAttachmentDisplay : public CursesContainer,
				public CursesKeyHandler {

	mail::ptr<CursesMessage> messageInfoPtr;

	std::list<Curses *> children; // Labels created in this container.

	// A non-multipart attachments.

	class Attachment : public CursesButton {

		CursesAttachmentDisplay *parent;
	public:

		mail::mimestruct *mime;
		mail::envelope *env;

		Attachment(CursesAttachmentDisplay *parentArg,
			   mail::mimestruct *mimeArg,
			   mail::envelope *envArg,
			   std::string name);
		~Attachment();

		void clicked();
		bool processKeyInFocus(const Curses::Key &key);
	};

	class KeyImportHelper;

public:
	CursesAttachmentDisplay(CursesContainer *parent,
			     CursesMessage *messageArg);
	~CursesAttachmentDisplay();

private:
	void createAttList(mail::mimestruct *mimePtr, int &rowNum,
			   int nestingLevel);

	void createMsgAtt(mail::mimestruct *mimePtr,
			  mail::envelope *env, int &rowNum, int nestingLevel);

public:
	// Inherited from Curses
	int getWidth() const;
	int getHeight() const;

	bool isFocusable();
	void requestFocus();

	// Inherited from CursesKeyHandler

	bool processKey(const Curses::Key &key);
	bool listKeys( std::vector< std::pair<std::string, std::string> > &list);

	void open(mail::mimestruct *mimePtr);
	// Open a message/rfc822 attachment

	void download(Attachment *a);
	// Download an attachment.

};

#endif
