/* $Id: opendialog.C,v 1.2 2003/06/11 22:36:31 mrsam Exp $
**
** Copyright 2003, Double Precision Inc.
**
** See COPYING for distribution information.
*/

#include "config.h"
#include "opendialog.H"
#include "gettext.H"
#include "curses/cursesmainscreen.H"
#include "curses/cursesstatusbar.H"
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

using namespace std;

extern CursesMainScreen *mainScreen;
extern CursesStatusBar *statusBar;

OpenDialog::OpenDialog() : CursesFileReq(mainScreen,
					 _("Open: "),
					 _("Directory: ")), closing(false)
{
}

OpenDialog::~OpenDialog()
{
}

void OpenDialog::selected(string filenameArg)
{
	struct stat stat_buf;

	if (stat(filenameArg.c_str(), &stat_buf))
	{
		statusBar->clearstatus();
		statusBar->status(strerror(errno), statusBar->SYSERROR);
		statusBar->beepError();
		return;
	}

	filename=filenameArg;
	Curses::keepgoing=false;
	closing=true;
}

void OpenDialog::abort()
{
	filename="";
	keepgoing=false;
	closing=true;
}

// We always call this function, so take the opportunity to reset keepgoing.

OpenDialog::operator string()
{
	if (closing)
		keepgoing=true;
	return filename;
}

