/* $Id: savedialog.C,v 1.2 2003/06/11 22:36:31 mrsam Exp $
**
** Copyright 2003, Double Precision Inc.
**
** See COPYING for distribution information.
*/
#include "config.h"
#include "savedialog.H"
#include "myserver.H"
#include "myserverpromptinfo.H"
#include "gettext.H"
#include "curses/cursesmainscreen.H"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

using namespace std;

extern CursesMainScreen *mainScreen;

SaveDialog::SaveDialog(string defaultName) : CursesFileReq(mainScreen,
							   _("Save As: "),
							   _("Directory: ")),
					     closing(false)
{
	setFilename(defaultName);
}

SaveDialog::~SaveDialog()
{
}

void SaveDialog::selected(string filenameArg)
{
	struct stat stat_buf;

	if (stat(filenameArg.c_str(), &stat_buf) == 0)
	{
		myServer::promptInfo response=
			myServer::prompt(myServer::promptInfo(_("Overwrite existing file? (Y/N) "))
					 .yesno());

		if (response.abortflag || (string)response != "Y")
			return;
	}

	filename=filenameArg;
	Curses::keepgoing=false;
	closing=true;
}

void SaveDialog::abort()
{
	filename="";
	keepgoing=false;
	closing=true;
}

// We always call this function, so take the opportunity to reset keepgoing.

SaveDialog::operator string()
{
	if (closing)
		keepgoing=true;
	return filename;
}

