/* $Id: addressbookadd.H,v 1.1 2003/05/27 14:09:08 mrsam Exp $
**
** Copyright 2002, Double Precision Inc.
**
** See COPYING for distribution information.
*/
#ifndef libmail_addressbookadd_H
#define libmail_addressbookadd_H

#include "addressbook.H"
#include "structure.H"
#include "addmessage.H"

//
// Add new address book entry.

class mail::addressbook::Add : public mail::callback::message {

	mail::ptr<mail::addressbook> addressBook;
	mail::addressbook::Entry newEntry;
	std::string oldUid;
	mail::callback &callback;

	mail::addMessage *addMessage;

	void success(std::string successMsg);
	void (mail::addressbook::Add::*successFunc)(std::string);
	void added(std::string successMsg);
	void checked(std::string successMsg);
	void reindexed(std::string successMsg);

	void fail(std::string failMsg);

	void messageEnvelopeCallback(size_t messageNumber,
				     const class mail::envelope &envelope);
	void reportProgress(size_t bytesCompleted,
			    size_t bytesEstimatedTotal,

			    size_t messagesCompleted,
			    size_t messagesEstimatedTotal);
public:
	Add(mail::addressbook *addressBookArg,
	    mail::addressbook::Entry entryArg,
	    std::string oldUidArg,
	    mail::callback &callbackArg);
	~Add();

	void go();
};

#endif
