/* $Id: addressbooksearch.C,v 1.1 2003/05/27 14:09:08 mrsam Exp $
**
** Copyright 2002, Double Precision Inc.
**
** See COPYING for distribution information.
*/
#include "libmail_config.h"
#include "addressbooksearch.H"

using namespace std;

mail::addressbook::Search::Search(mail::addressbook *addressBookArg,
				  vector<mail::address> &addrListArg,
				  mail::callback &callbackArg)
	: addressBook(addressBookArg),
	  addrList(addrListArg),
	  callback(callbackArg)
{
}

mail::addressbook::Search::~Search()
{
}

void mail::addressbook::Search::success(std::string msg)
{
	go();
}

void mail::addressbook::Search::fail(std::string msg)
{
	try {
		callback.fail(msg);
		delete this;
	} catch (...) {
		delete this;
		LIBMAIL_THROW();
	}
}

void mail::addressbook::Search::reportProgress(size_t bytesCompleted,
					       size_t bytesEstimatedTotal,

					       size_t messagesCompleted,
					       size_t messagesEstimatedTotal)
{
	callback.reportProgress(bytesCompleted, bytesEstimatedTotal,
				messagesCompleted, messagesEstimatedTotal);
}

void mail::addressbook::Search::go()
{
	list<string>::iterator b=uidList.begin(), e=uidList.end();

	if (b == e) // Finished the list.
	{
		try {
			callback.success("OK");
			delete this;
		} catch (...) {
			delete this;
			LIBMAIL_THROW();
		}
		return;
	}

	// Just get the next address book entry.

	string uid= *b;

	uidList.erase(b);

	addressBook->getAddressList( uid, addrList, *this );
}
